package UroIrmPackage;

import ij.*;
import ij.gui.*;
import java.awt.*;
import java.util.*;
import java.awt.event.*;

/** class for the window OptionGraph in the class UorIrmGraph */
public class OptionGraphDialog extends GenericDialog implements GraphInterface{

	private Hashtable table;
	int oldAbscisse =-1 , oldOrdonnee=-1;
	private int digits,nbChoice = 0;
	

	public OptionGraphDialog(String text,Hashtable table,int digits){
		super(text);
		if( table == null)
			this.table = new Hashtable();
		else
			this.table = table;
		this.digits = digits;
	}

/** add a Choice */
	public void addChoicePlot(String label,String[] data,String defaultData){
		addChoice(label,data,defaultData);
		((Choice)choice.elementAt(nbChoice)).addItemListener(this);		
		nbChoice ++;
	}

	protected void setup() {
		setPlotInfo();
	}
 	
	
	public void itemStateChanged(ItemEvent e) {
 		setPlotInfo();
	}
	
	public void textValueChanged(TextEvent e) {
 		setPlotInfo();
	}

	String[] key2Array(){
		int index = table.size();
		if ( index < 1 )
			return null;
		String[] result = new String[5];
		int i =0;
		for ( Enumeration enum = table.keys(); enum.hasMoreElements();){
			result[i] = (String)(enum.nextElement());
			i ++;
		}
		return result;		 
	}

	void setPlotInfo(){
		setPlotInfoAbscisse();
		setPlotInfoOrdonnee();
	}

	void setPlotInfoAbscisse(){
		int choice1 = ((Choice)choice.elementAt(0)).getSelectedIndex();
		if ( choice1 < 0 )
			return ;
		String key = ABSCISSE_CHOICE[choice1];
		if( !table.containsKey(key) || ( oldAbscisse == choice1 ) )
			return ;
		float[] value=(float[])(table.get(key));
		TextField tf ;
		int precision = adaptDigit(value);
		tf = (TextField)numberField.elementAt(0); tf.setText(IJ.d2s(value[0],precision));
		tf = (TextField)numberField.elementAt(1); tf.setText(IJ.d2s(value[1], precision));
		oldAbscisse = choice1;
	}

	
	void setPlotInfoOrdonnee(){
		int choice1 = ((Choice)choice.elementAt(1)).getSelectedIndex();
		if ( choice1 < 0 )
			return ;
		String key = ORDONNEE_CHOICE[choice1];
		if( !table.containsKey(key) || ( oldOrdonnee == choice1 ) )
			return ;
		float[] value=(float[])(table.get(key));
		TextField tf ;
		int precision = adaptDigit(value);
		tf = (TextField)numberField.elementAt(2); tf.setText(IJ.d2s(value[0], precision));
		tf = (TextField)numberField.elementAt(3); tf.setText(IJ.d2s(value[1], precision));
		oldOrdonnee = choice1;
	}

	int adaptDigit(float[] value){
		if ( value == null )
			return -1;
		int res =-1;
		for (int i=0;i<value.length;i++){
			float v = value[i];
			if ( v == 0 ) 
				continue;
			int n = f2i(v);
			int newDigit = 0;			
			while ( n == 0 ){
				v*=10;n=f2i(v);newDigit ++;
			} 
			if ( newDigit > res ) 
				res = newDigit;
		}
		if (res <0 ) 
			res = 0 ;
		return res;
	}

	private int f2i(float x ) {
		return((new Float(x)).intValue());
	}

	public int getNumber(Object field) {
		TextField tf = (TextField)field;
		String theText = tf.getText();
		double value;
		Double d;
		try {d = new Double(theText);}
		catch (NumberFormatException e){
			d = null;
		}
		if (d!=null)
			return (int)d.doubleValue();
		else
			return 0;
      }


}
