package UroIrmPackage;

import ij.*;
import java.awt.*;
import java.util.*;

public class UroIrmDebug {
	// Debug
	private static boolean DEBUG ;
	private static int DEBUG_LEVEL;
	private static int[] DEBUG_NIVEL ;
	private static String title;
	
	public UroIrmDebug(String title, int[] debug, int level, boolean run){
		DEBUG = run;
		DEBUG_LEVEL = level;
		DEBUG_NIVEL = debug;
		this.title=title;
	}

	public void ShowResult(DicomHashtable table,int n){
		if ( !DEBUG ||DEBUG_NIVEL[n] != DEBUG_LEVEL ) 
			return;
		IJ.write(title);
		int tablecount = table.size();
		for (int i=1;i<(tablecount+1);i++)
			IJ.write(table.getKey(i));
	}
	
	public void Print(DicomHashtable table, int n ){
		if ( !DEBUG ||DEBUG_NIVEL[n] != DEBUG_LEVEL ) 
			return;
		IJ.write(title);	
		IJ.write( " the table size is  " + table.size());
		Enumeration enu = table.keys();
		while ( enu.hasMoreElements()){
			String currentKey =(String)enu.nextElement(); 
			LinkedList l = ((LinkedList)(table.get(currentKey)));
			IJ.write( "\t the key is  " + currentKey);
			IJ.write("\t size of the list " + l.size());
			IJ.write(" properties " + (String)(l.getFirst()));		
			IJ.write(" result =  "+ table.getPatientID(currentKey));
		}


	}


	public void Print(String name, int n ){
		if ( !DEBUG || DEBUG_NIVEL[n] != DEBUG_LEVEL ) 
			return;
		IJ.write(title);
		IJ.write(name + " " );
	}

	public void Print(String name, float x ,int n ){
		if ( !DEBUG ||DEBUG_NIVEL[n] != DEBUG_LEVEL ) 
			return;
		IJ.write(title );
		IJ.write(name + "  " + f2s(x));
	}

	public void Print(String name, int x ,int n ){
		if ( !DEBUG ||DEBUG_NIVEL[n] != DEBUG_LEVEL ) 
			return;
		IJ.write(title);
		IJ.write(name + "  " + String.valueOf(x));
	}

	public void Array(String name, float[] mat , int n ) {
		if ( !DEBUG ||DEBUG_NIVEL[n] != DEBUG_LEVEL ) 
			return;
		String text = "";
		text += name + " length " + mat.length + " ; " + "  mat = " ;
		for( int i = 0 ;i < mat.length; i++ )
			text += f2s(mat[i]) + " ; "  ;
		IJ.write(title);
		IJ.write(text);
	} 


	public void Array(String name, int[] mat , int n ) {
		if ( !DEBUG ||DEBUG_NIVEL[n] != DEBUG_LEVEL ) 
			return;
		String text = "";
		text += name + " length " + mat.length + " ; " + "  mat = " ;
		for( int i = 0 ;i < mat.length; i++ )
			text += String.valueOf(mat[i]) + " ; " ;
		IJ.write(title);
		IJ.write(text);
	} 


	public void Array(String name, int[][] plot , int n ) {
		if ( !DEBUG ||DEBUG_NIVEL[n] != DEBUG_LEVEL ) 
			return;
		String text;
		int length = (((plot[0]).length > (plot[1]).length )? (plot[1]).length :(plot[0]).length);
		IJ.write ( name + " length =  "  + length);
		for (int i = 0 ; i < length ; i++){
			text = " line " + String.valueOf(i) + " ;  " ;
			for (int j = 0 ; j < length ; j++){
				text += String.valueOf(plot[i][j]) + " ; " ;
			}
		IJ.write(title);
			IJ.write(text);
		}
	}
	
	public void Array(String name, float[][] plot , int n ) {
		if ( !DEBUG ||DEBUG_NIVEL[n] != DEBUG_LEVEL ) 
			return;
		String text;
		int length = (((plot[0]).length > (plot[1]).length )? (plot[1]).length :(plot[0]).length);
		IJ.write ( name + " length =  "  + length);
		for (int i = 0 ; i < length ; i++){
			text = " line " + String.valueOf(i) + " ;  " ;
			for (int j = 0 ; j < length ; j++){
				text += f2s(plot[i][j]) + " ; " ;
			}
		IJ.write(title);
			IJ.write(text);
		}
	}

	public void addPanel(Frame instance,GridBagConstraints c,int i,int n){
		if ( !DEBUG ||DEBUG_NIVEL[n] != DEBUG_LEVEL ) 
			return;

		Panel panel = new Panel();
		Color couleur;
		if ( i<0 )
			couleur = Color.yellow;
		else
			couleur = (i%2==0)? Color.blue:Color.green;
		panel.setBackground(couleur);
		instance.add(panel,c);
	}

	public void addPanel(Frame instance,GridBagConstraints c,Color couleur,int n){
		if ( !DEBUG ||DEBUG_NIVEL[n] != DEBUG_LEVEL ) 
			return;
		Panel panel = new Panel();
		panel.setBackground(couleur);
		instance.add(panel,c);
	}

	private String f2s(float x ) {
		return((new Float(x)).toString());
	}


}

